/******************************************************************************
 * Locke's   __                      __         NIM Server Software           *
 * ___ ___  (__)__    __ __   __ ___|  | v5     Version 5 (ALPHA)             *
 * |  /   \  __|  \__/  |  | |  |      |        unreleased+revamped 2004      *
 * |       ||  |        |  \_|  | ()   |                                      *
 * |    |  ||  |  |__|  |       |      |                                      *
 * |____|__|___|__|  |__|\___/__|______|        http://www.nimud.org/nimud    *
 *   n a m e l e s s i n c a r n a t e          dedicated to chris cool       *
 ******************************************************************************/

#if defined(BSD)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "nimud.h"


/*
 * This code is used for number and string list manipulations.
 * It lets you generate strings based on lists of strings,
 * do checks in a list, or add / remove elements from a list.
 */

NUMBER_LIST *add_num_nodups( NUMBER_LIST **nlist, int num )
{
    NUMBER_LIST *pNum;
 
    if ( num_in_list( *nlist, num ) ) return;
    
    pNum = new_number_list( );
    pNum->num  = num;
    pNum->next = *nlist;
    return pNum;     
}     


NUMBER_LIST *add_num_list( NUMBER_LIST **nlist, int num )
{
    NUMBER_LIST *pNum;

    pNum = new_number_list( );
    pNum->num = num;
    pNum->next = *nlist;
    return pNum;     
}


NUMBER_LIST *rem_num_list( NUMBER_LIST **nlist, int num )
{
    return *nlist;
}

bool num_in_list( NUMBER_LIST *nlist, int num )
{
     NUMBER_LIST *pNum;

     for( pNum = nlist; pNum != NULL;  pNum = pNum->next )
     {
         if ( pNum->num == num ) return TRUE; 
     }      

     return FALSE;
}
  
/*
 * This code is used for number and string list manipulations.
 * It lets you generate strings based on lists of strings,
 * do checks in a list, or add / remove elements from a list.
 */

STRING_LIST *add_str_nodups( STRING_LIST **nlist, char *str )
{
    STRING_LIST *pStr;
 
    if ( str_in_list( *nlist, str ) ) return;
    
    pStr = new_string_list( );
    pStr->str  = str_dup( str );
    pStr->next = *nlist;
    return pStr;     
}     

STRING_LIST *add_str_list( STRING_LIST **nlist, char *str )
{
    STRING_LIST *pStr;

    pStr = new_string_list( );
    pStr->str = str_dup( str );
    pStr->next = *nlist;
    return pStr;     
}

STRING_LIST *rem_str_list( STRING_LIST **nlist, char *str )
{
     return *nlist;
}

bool str_in_list( STRING_LIST *nlist, char *str )
{
     STRING_LIST *pStr;

     for( pStr = nlist; pStr != NULL;  pStr = pStr->next )
     {
         if ( !str_cmp( pStr->str, str ) ) return TRUE; 
     }      

     return FALSE;
}
  

