/*
******************************************************************************
* Locke's   __ -based on merc v2.2-____        NIM Server Software           *
* ___ ___  (__)__    __ __   __ ___| G| v4.0   Version 4.0 GOLD EDITION      *
* |  /   \  __|  \__/  |  | |  |     O|        documentation release         *
* |       ||  |        |  \_|  | ()  L|        Hallow's Eve 1999             *
* |    |  ||  |  |__|  |       |     D|                                      *
* |____|__|___|__|  |__|\___/__|______|        http://www.nimud.org/nimud    *
*   n a m e l e s s i n c a r n a t e          dedicated to chris cool       *
******************************************************************************
 */

/*
 * Trigger types for repetitive loops, command etc.
 */
#define TRIG_COMMAND        0  /* All       = When a Command is Typed        */
#define TRIG_EACH_PULSE     1  /* Mobs/Objs = Triggered Each Pulse           */
#define TRIG_COMBAT         2  /* All       = Each Round                     */
#define TRIG_TICK_PULSE     3  /* Mobs/Objs = Tick       Scene = When Spawn   */
#define TRIG_BORN           4  /* Mobs/Objs = Creation   Scene = On Startup   */
#define TRIG_GETS           5  /* Objs      = When Taken Mobs = when given   */
#define TRIG_SAY            6  /* All       = Any communications (NFI)       */

#define TRIG_KILLS          8  /* Mobs/Objs = Kills                          */
#define TRIG_DIES           9  /* Mobs      = Dies  Objs/Scene = Dies Nearby  */
#define TRIG_ENTER         10  /* All       = Someone Enters                 */
#define TRIG_MOVES         11  /* Mobs/Scene = Someone Leaves                 */

#define TRIG_LOOKS	   12  /* All	    = Called when looked at.	     */

#define TRIG_EXIT          13  /* Exits     = Called with parameter on exits */

#define TRIG_ALERT         14  /* All       = Called by an alert() function  */
#define TRIG_SPELL         15  /* Spell     = Called by a spell caster       */

/*
 * Internally used bits for triggers.
 */
#define SCRIPT_HALT         0x00000001   /* current=NULL & disallow trig     */

#define MAX_LOOPS           1000   /* Max number of total goto()s per script */


#define TYPE_PROP            0
#define TYPE_SCENE           1
#define TYPE_ACTOR            2
#define TYPE_STRING         3
#define TYPE_ALIAS          4
#define TYPE_EXIT           5

#define MAX_PARAMS          6

#define FUNC(str, function_call)                \
 if ( !str_cmp(func_name, str) ) value = function_call

/* script.c */
TRIGGER_DATA * curtrig args( ( void * owner, int type ) );
VARIABLE_DATA **  varlist   args( ( void * owner, int type ) );

void trigger_list       args( ( PROP_DATA *list, int ttype, PLAYER_DATA  *actor,
                               PROP_DATA *catalyst, char *astr, char *bstr ) );
int script_update      args( ( void * owner, int type, int ttype,
                               PLAYER_DATA *actor, PROP_DATA *catalyst,
                               char *astr, char *bstr  ) );
void parse_script      args( ( TRIGGER_DATA *trig, void * owner, int type ) );
